"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useConnectionCheck = void 0;

var _react = require("react");

var _connectionChecker = require("../connection-checker");

var _beClient = require("../be-client");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useConnectionCheck = function useConnectionCheck(channelRid, maxAbsence) {
  var running = (0, _react.useRef)();

  var _useState = (0, _react.useState)(undefined),
      _useState2 = _slicedToArray(_useState, 2),
      connStatus = _useState2[0],
      setConnStatus = _useState2[1];

  var connectionRef = (0, _react.useRef)((0, _connectionChecker.getConnectionChecker)(setConnStatus));
  var _connectionRef$curren = connectionRef.current,
      check = _connectionRef$curren.check,
      bump = _connectionRef$curren.bump;
  (0, _react.useEffect)(function () {
    if (!channelRid || !maxAbsence) return undefined;
    var unsub = (0, _beClient.fromChannel)({
      rid: channelRid,
      last: true,
      cb: bump,
      path: 'ts'
    });
    running.current = setInterval(function () {
      return check(maxAbsence);
    }, 2000);
    return function () {
      if (unsub) unsub();

      if (running.current) {
        clearInterval(running.current);
        running.current = undefined;
      }
    };
  }, [channelRid, maxAbsence]);
  return connStatus;
};

exports.useConnectionCheck = useConnectionCheck;