"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transformConf = exports.confTransformer = void 0;

var _lodash = _interopRequireDefault(require("lodash.get"));

var _lodash2 = _interopRequireDefault(require("lodash.set"));

var _jsonTransformerJs = _interopRequireDefault(require("json-transformer-js"));

var _minimalLispParser = require("json-rule-processor/dist/minimal-lisp-parser");

var recompose = _interopRequireWildcard(require("recompose"));

var R = _interopRequireWildcard(require("ramda"));

var dataUtils = _interopRequireWildcard(require("./data-utils"));

var dmUtils = _interopRequireWildcard(require("./dm-utils"));

var uiUtils = _interopRequireWildcard(require("./ui-utils"));

var trUtils = _interopRequireWildcard(require("./transforms"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// import { req, reqEntityConf } from './be-client';
// import { withChannelData } from './withChannelData';
// import { withSub } from './withSub';
// import { withPresence } from './withPresence';
// import { withAsync } from './withAsync';
var confTransformer = R.curry(function (_ref, context) {
  var staticContext = _ref.staticContext,
      transforms = _ref.transforms,
      jispParserMutator = _ref.jispParserMutator;
  var jisp = (0, _minimalLispParser.functionalParserWithVars)(context, {
    envExtra: staticContext
  });
  R.forEachObjIndexed(function (func, name) {
    jisp["Re.".concat(name)] = func;
  }, recompose);
  if (jispParserMutator) jispParserMutator(jisp);
  var transformer = (0, _jsonTransformerJs["default"])({
    defaultLevel1Transform: function defaultLevel1Transform(v, k) {
      return (0, _lodash["default"])((0, _lodash2["default"])(context, k, v), k);
    },
    transforms: _objectSpread({
      '%ml%': function ml(arr) {
        try {
          return jisp.evalWithLog(arr);
        } catch (err) {
          console.error('jisp.eval:', err);
          return undefined;
        }
      }
    }, transforms)
  });
  return transformer;
});
exports.confTransformer = confTransformer;
var transformConf = R.curry(function (_ref2, context, configJson) {
  var staticContext = _ref2.staticContext,
      transforms = _ref2.transforms;
  if (!configJson) return undefined;
  var transformer = confTransformer({
    staticContext: _objectSpread({
      '%': R.modulo,
      tapLog: R.tap(function (x) {
        return console.log('TAPPING:', x);
      }),
      utils: _objectSpread({}, uiUtils, {}, dataUtils, {}, dmUtils),
      'utils.dm': dmUtils,
      'utils.ui': uiUtils,
      'utils.data': dataUtils,
      'utils.tr': trUtils
    }, staticContext),
    transforms: transforms
  }, context);
  return transformer(configJson);
});
exports.transformConf = transformConf;