"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/styles");

var _gaugeface = require("gauge-animated/lib/gaugeface");

var _lib = require("gauge-animated/lib");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function hexToRgbArray(hexStr) {
  return [0, 0, 0].map(function (v, i) {
    return parseInt(hexStr.slice(i * 2, 2 * (i + 1)), 16);
  });
}

var ColorGauge =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ColorGauge, _React$Component);

  function ColorGauge() {
    _classCallCheck(this, ColorGauge);

    return _possibleConstructorReturn(this, _getPrototypeOf(ColorGauge).apply(this, arguments));
  }

  _createClass(ColorGauge, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          startColor = _this$props.startColor,
          endColor = _this$props.endColor,
          size = _this$props.size,
          min = _this$props.min,
          max = _this$props.max,
          markerColors = _this$props.markerColors,
          valueDisplayPostfix = _this$props.valueDisplayPostfix,
          theme = _this$props.theme,
          rest = _objectWithoutProperties(_this$props, ["startColor", "endColor", "size", "min", "max", "markerColors", "valueDisplayPostfix", "theme"]);

      var steps = max - min;
      var c1 = hexToRgbArray(startColor);
      var c2 = hexToRgbArray(endColor);
      var cDiff = c2.map(function (v, i) {
        return v - c1[i];
      });
      var cStep = cDiff.map(function (v) {
        return v / steps;
      });
      var fontFamily = ' '; // const fontFamily = theme.typography.fontFamily.split('"')[1];

      var options = _objectSpread({
        size: size,
        fontFamily: fontFamily,
        scaleLabelFontFamily: fontFamily,
        faceTextFontFamily: fontFamily,
        valueDisplayFontFamily: fontFamily,
        startAngle: Math.PI,
        stopAngle: Math.PI * 2,
        needleAngleMin: Math.PI,
        needleAngleMax: Math.PI * 2,
        labelSteps: 0,
        stopPinColor: 0,
        markerWidth: size / 29,
        markerLength: size * 0.16,
        markerColors: markerColors || function (i) {
          return "rgb(\n        ".concat((c1[0] + cStep[0] * i).toFixed(0), ",\n        ").concat((c1[1] + cStep[1] * i).toFixed(0), ",\n        ").concat((c1[2] + cStep[2] * i).toFixed(0), ")");
        },
        valueDisplay: true,
        valueDisplayPostfix: valueDisplayPostfix,
        valueDisplayRadius: -0.2,
        valueDisplayFontSize: size / 7,
        min: min,
        max: max,
        stepValue: 1,
        mediumSteps: 0,
        largeSteps: 0,
        needleSvg: function needleSvg(siZe) {
          var c = 250;
          var scale = siZe / 500;
          return (0, _gaugeface.stringToElement)("\n          <svg viewBox=\"0 0 ".concat(siZe, " ").concat(siZe, "\" xmlns=\"http://www.w3.org/2000/svg\" style=\"width:").concat(siZe, "px; height:").concat(siZe, "px;\">\n            <g>\n              <g transform=\"scale(").concat(scale, ")\">\n                <path d=\"M ").concat(c * 1.6, " ").concat(c + 18, " L ").concat(c * 1.91, " ").concat(c, " L ").concat(c * 1.6, " ").concat(c - 18, " z\" fill=\"#fff\" stroke=\"#fff\"/>\n              </g>\n            </g>\n          </svg>\n        "));
        }
      }, rest);

      this.gauge = (0, _lib.createGauge)(this.div, options);
      this.gauge.setTarget(this.props.value);
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      // console.log('ColorGauge', this.props.value);
      if (nextProps.value !== this.props.value) this.gauge.setTarget(nextProps.value);
      return false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var size = this.props.size;
      return _react["default"].createElement("div", {
        style: {
          width: size,
          height: size * 0.55,
          overflow: 'hidden'
        }
      }, _react["default"].createElement("style", null, ".gauge-value-display { font-size: ".concat(size / 8, "px }")), _react["default"].createElement("div", {
        ref: function ref(c) {
          _this.div = c;
        }
      }));
    }
  }]);

  return ColorGauge;
}(_react["default"].Component);

ColorGauge.propTypes = {
  theme: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  startColor: _propTypes["default"].string,
  endColor: _propTypes["default"].string,
  size: _propTypes["default"].number,
  min: _propTypes["default"].number,
  max: _propTypes["default"].number,
  value: _propTypes["default"].number,
  markerColors: _propTypes["default"].func,
  valueDisplayPostfix: _propTypes["default"].string
};
ColorGauge.defaultProps = {
  startColor: 'ff0000',
  endColor: '00ff00',
  size: 500,
  min: 0,
  max: 100,
  value: undefined,
  markerColors: undefined,
  valueDisplayPostfix: '&deg;C'
};

var _default = (0, _styles.withTheme)(ColorGauge);

exports["default"] = _default;