"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FlexIcon = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _styles = require("@material-ui/styles");

require("mdi/css/materialdesignicons.min.css");

var _styles2 = require("@material-ui/core/styles");

var _Icon = _interopRequireDefault(require("@material-ui/core/Icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// import { between } from '../transforms';
var stringToThemeColor = function stringToThemeColor(string, theme) {
  if (string === 'inherit') return 'inherit';
  if (string === 'secondary') return theme.palette.secondary.main;
  if (string === 'primary') return theme.palette.primary.main;
  if (string === 'action') return theme.palette.action.active;
  if (string === 'disabled') return theme.palette.action.disabled;
  if (string === 'error') return theme.palette.error.main;
  return string;
}; // const clampIconSize = R.cond([
//   [between(0, 21), R.always(18)],
//   [between(21, 30), R.always(24)],
//   [between(30, 42), R.always(36)],
//   [between(42, 100000), R.always(48)],
// ]);


var sizeToNumber = {
  sm: 18,
  md: 24,
  lg: 36,
  xl: 48
};

var sizeToNum = function sizeToNum(size) {
  return typeof size === 'string' ? sizeToNumber[size] || sizeToNumber.xl : size;
};

var propTypes = {
  children: _propTypes["default"].node,
  theme: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  icon: _propTypes["default"].string,
  className: _propTypes["default"].string,
  size: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  color: _propTypes["default"].string // inherit, secondary, primary, action, disabled or error

};
var defaultProps = {
  children: undefined,
  color: undefined,
  className: '',
  size: 24,
  style: {},
  icon: undefined
};
var useStyles = (0, _styles.makeStyles)(function () {
  return {
    mdicon: {
      '&::before': {
        fontSize: 'inherit !important'
      }
    }
  };
});

var FlexIconC = _react["default"].memo(function (_ref) {
  var icon = _ref.icon,
      style = _ref.style,
      theme = _ref.theme,
      color = _ref.color,
      size = _ref.size,
      children = _ref.children,
      className = _ref.className;
  var classes = useStyles();
  var iconStr = (children || icon).trim();
  var mdi = iconStr.startsWith('mdi-');
  var sizeNumber = sizeToNum(size); // console.log('FlexIcon:', size, sizeNumber);

  if (mdi) {
    var _classnames;

    return _react["default"].createElement("i", {
      style: _objectSpread({
        color: stringToThemeColor(color, theme),
        lineHeight: "".concat(sizeNumber, "px"),
        fontSize: "".concat(sizeNumber, "px"),
        height: sizeNumber,
        width: sizeNumber
      }, style),
      className: (0, _classnames2["default"])((_classnames = {
        mdi: true,
        'mdi-48px': true
      }, _defineProperty(_classnames, iconStr, true), _defineProperty(_classnames, className, !!className), _defineProperty(_classnames, classes.mdicon, true), _classnames))
    });
  }

  var inlineStyle = _objectSpread({
    fontSize: sizeNumber
  }, style);

  if (color && (color.startsWith('#') || color.startsWith('rgb'))) {
    inlineStyle.color = color;
    return _react["default"].createElement(_Icon["default"], {
      style: inlineStyle,
      className: className
    }, iconStr);
  }

  return _react["default"].createElement(_Icon["default"], {
    style: inlineStyle,
    color: color,
    className: className
  }, iconStr);
});

FlexIconC.propTypes = propTypes;
FlexIconC.defaultProps = defaultProps;
var FlexIcon = (0, _styles2.withStyles)(function () {
  return {};
}, {
  withTheme: true
})(FlexIconC);
exports.FlexIcon = FlexIcon;