"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HorizontalTableCell = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var R = _interopRequireWildcard(require("ramda"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _styles = require("@material-ui/core/styles");

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].string).isRequired,
  className: _propTypes["default"].string,
  content: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].string]).isRequired,
  label: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].string]).isRequired
};
var defaultProps = {
  className: undefined
};

var styles = function styles(theme) {
  return {
    contentElement: {
      display: 'inline-flex',
      flexDirection: 'column',
      justifyContent: 'flex-start',
      alignItems: 'flex-start',
      borderLeft: "solid 2px ".concat(theme.palette.divider),
      paddingLeft: theme.spacing(1)
    },
    labelText: {
      color: R.path(['palette', 'text', 'secondary'])(theme)
    }
  };
};

var HorizontalTableCellC = function HorizontalTableCellC(_ref) {
  var _classnames;

  var classes = _ref.classes,
      label = _ref.label,
      content = _ref.content,
      className = _ref.className;
  return _react["default"].createElement("div", {
    className: (0, _classnames2["default"])((_classnames = {}, _defineProperty(_classnames, classes.contentElement, true), _defineProperty(_classnames, className, !!className), _classnames))
  }, typeof label === 'string' ? _react["default"].createElement(_Typography["default"], {
    variant: "caption",
    className: classes.labelText
  }, label) : label, typeof content === 'string' ? _react["default"].createElement(_Typography["default"], null, content || '-') : content);
};

HorizontalTableCellC.propTypes = propTypes;
HorizontalTableCellC.defaultProps = defaultProps;
var HorizontalTableCell = (0, _styles.withStyles)(styles)(HorizontalTableCellC);
exports.HorizontalTableCell = HorizontalTableCell;