"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Image = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _FlexIcon = require("./FlexIcon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = function styles() {
  return {
    icon: {
      position: 'relative',
      fontSize: 60,
      textAlign: 'center'
    },
    image: {
      backgroundSize: 'contain',
      backgroundRepeat: 'no-repeat',
      backgroundPosition: 'center'
    }
  };
};

var propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  src: _propTypes["default"].string,
  blackBackground: _propTypes["default"].bool,
  forVideo: _propTypes["default"].bool
};
var defaultProps = {
  blackBackground: false,
  src: undefined,
  forVideo: false,
  style: {}
};

var ImageC = function ImageC(_ref) {
  var style = _ref.style,
      src = _ref.src,
      blackBackground = _ref.blackBackground,
      classes = _ref.classes,
      forVideo = _ref.forVideo;

  // this.renders += 1;
  // if (this.renders > 3 && (!src || this.lastSrc === src)) return null; // prevent render
  // this.lastSrc = src;
  // console.log('Image src:', src, blackBackground, forVideo);
  if (!src) {
    return _react["default"].createElement(_FlexIcon.FlexIcon, {
      size: "xl",
      style: {
        fontSize: 48,
        color: blackBackground ? 'white' : 'black'
      }
    }, forVideo ? 'videocam_off' : 'mdi-image-off');
  }

  var urlIsh = src.startsWith('http') && src || (src.startsWith('data:') ? src : "data:jpeg;base64,".concat(src)); // console.log('Image urlIsh:', urlIsh);

  return _react["default"].createElement("div", {
    className: classes.image,
    style: _objectSpread({
      backgroundImage: "url(".concat(urlIsh, ")")
    }, style)
  });
};

ImageC.propTypes = propTypes;
ImageC.defaultProps = defaultProps;
var Image = (0, _styles.withStyles)(styles)(ImageC);
exports.Image = Image;