"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Notifications = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _Collapse = _interopRequireDefault(require("@material-ui/core/Collapse"));

var _Icon = _interopRequireDefault(require("@material-ui/core/Icon"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var R = _interopRequireWildcard(require("ramda"));

var _fp = require("date-fns/fp");

var _dmUtils = require("../dm-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var severityMap = {
  none: {
    icon: 'chat_bubble_outline'
  },
  minor: {
    icon: 'announcement'
  },
  major: {
    icon: 'warning',
    color: 'orange'
  },
  critical: {
    icon: 'report',
    color: 'red'
  },
  success: {
    icon: 'chat_bubble_outline'
  },
  info: {
    icon: 'announcement'
  },
  warning: {
    icon: 'warning',
    color: 'orange'
  },
  error: {
    icon: 'report',
    color: 'red'
  }
};

var styles = function styles(theme) {
  return {
    wrapper: {
      overflowY: 'auto',
      overflowX: 'hidden',
      height: '100%'
    },
    icon: {
      alignSelf: 'center',
      paddingRight: theme.spacing(2)
    },
    text: {
      paddingLeft: 12
    }
  };
};

var propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  messages: _propTypes["default"].arrayOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var defaultProps = {
  style: {},
  messages: []
};

var Notification = function Notification(_ref) {
  var classes = _ref.classes,
      msg = _ref.msg;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      expanded = _useState2[0],
      setExpanded = _useState2[1];

  (0, _react.useEffect)(function () {
    setTimeout(function () {
      return setExpanded(true);
    }, 10);
  }, []);
  var _msg$ts = msg.ts,
      ts = _msg$ts === void 0 ? (0, _dmUtils.dateToTs)(new Date()) : _msg$ts,
      _msg$pl = msg.pl,
      pl = _msg$pl === void 0 ? [{}] : _msg$pl;
  var _pl$ = pl[0],
      _pl$$signal = _pl$.signal,
      signal = _pl$$signal === void 0 ? 'Unknown' : _pl$$signal,
      _pl$$severity = _pl$.severity,
      severity = _pl$$severity === void 0 ? 'none' : _pl$$severity;
  var iConf = severityMap[severity] || severityMap.none;
  return _react["default"].createElement(_Collapse["default"], {
    "in": expanded
  }, _react["default"].createElement("div", {
    style: {
      display: 'flex',
      padding: '12px 6px 12px 12px'
    }
  }, _react["default"].createElement(_Icon["default"], {
    className: classes.icon,
    style: iConf.color && {
      color: iConf.color
    }
  }, iConf.icon), _react["default"].createElement("div", {
    className: classes.text
  }, _react["default"].createElement(_Typography["default"], null, signal), _react["default"].createElement(_Typography["default"], {
    variant: "caption"
  }, (0, _fp.format)('d MMM HH:mm')((0, _dmUtils.tsToDate)(ts))))));
};

Notification.propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  msg: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired
};

var NotificationsC = function NotificationsC(_ref2) {
  var style = _ref2.style,
      messages = _ref2.messages,
      classes = _ref2.classes;
  return (// console.log('Notifications', messages);
    _react["default"].createElement("div", {
      style: style,
      className: classes.wrapper
    }, _react["default"].createElement(_Divider["default"], null), R.compose(R.map(function (msg) {
      return _react["default"].createElement("div", {
        key: msg.ts
      }, _react["default"].createElement(Notification, {
        classes: classes,
        msg: msg
      }), _react["default"].createElement(_Divider["default"], null));
    }), R.reverse, R.when(function (m) {
      return !Array.isArray(m);
    }, R.of))(messages))
  );
};

NotificationsC.propTypes = propTypes;
NotificationsC.defaultProps = defaultProps;
var hoc = (0, _styles.withStyles)(styles);
var Notifications = hoc(NotificationsC);
exports.Notifications = Notifications;