"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SearchableExpandableTable = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));

var _styles = require("@material-ui/core/styles");

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = _interopRequireDefault(require("@material-ui/core/Icon"));

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));

var _BottomNavigationAction = _interopRequireDefault(require("@material-ui/core/BottomNavigationAction"));

var _ExpansionPanel = _interopRequireDefault(require("@material-ui/core/ExpansionPanel"));

var _ExpansionPanelDetails = _interopRequireDefault(require("@material-ui/core/ExpansionPanelDetails"));

var _ExpansionPanelSummary = _interopRequireDefault(require("@material-ui/core/ExpansionPanelSummary"));

var _ExpansionPanelActions = _interopRequireDefault(require("@material-ui/core/ExpansionPanelActions"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _Avatar = _interopRequireDefault(require("@material-ui/core/Avatar"));

var R = _interopRequireWildcard(require("ramda"));

var _FlippableAvatar = require("./FlippableAvatar");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = function styles(theme) {
  return {
    container: {
      position: 'relative'
    },
    flexContainer: {
      justify: 'start',
      align: 'center',
      flex: 1
    },
    tools: {
      align: 'center',
      flex: 2
    },
    expandHeader: {
      lineHeight: '40px'
    },
    expandHeaderHover: {
      '&:hover': {
        background: theme.palette.action.hover
      }
    },
    searchField: {
      align: 'start',
      flex: 3,
      paddingLeft: theme.spacing(3),
      paddingBottom: 0
    },
    tooltipContainer: {
      position: 'absolute',
      right: 48,
      top: 8
    },
    tooltipBody: {
      maxWidth: 180
    },
    selectComponent: _defineProperty({}, theme.breakpoints.up('md'), {
      paddingLeft: theme.spacing(7)
    }),
    expandIcon: {
      transform: 'rotate(0deg) translateY(-50%) !important'
    },
    actionsPanel: {
      justifyContent: 'center'
    },
    primaryAction: {
      display: 'block',
      position: 'absolute',
      width: 64,
      height: 64,
      right: 0,
      top: 0,
      cursor: 'pointer'
    },
    heading: {
      color: theme.palette.text.hint
    },
    headings: {
      display: 'flex',
      padding: "".concat(theme.spacing(2), "px ").concat(theme.spacing(7), "px ").concat(theme.spacing(1), "px")
    },
    content: {
      display: 'block'
    },
    checkboxes: {
      height: 20,
      width: 20,
      paddingRight: theme.spacing(3)
    },
    avatar: {
      padding: 0,
      paddingRight: 16
    }
  };
};

var iconSizeCompensation = 32;

var filterHelper = function filterHelper(array, searchText) {
  if (!searchText) return true;

  for (var i = 0; i < array.length; i += 1) {
    var value = array[i].toString(); // console.log('filterHelper value:', value, searchText);

    if (value && value.toLowerCase().includes(searchText.toLowerCase())) {
      return true;
    }
  }

  return false;
};

var propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  theme: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  // width: PropTypes.string,
  // windowWidth: PropTypes.number.isRequired,
  selectComponent: _propTypes["default"].node,
  onSelected: _propTypes["default"].func,
  data: _propTypes["default"].objectOf(_propTypes["default"].any),
  headings: _propTypes["default"].arrayOf(_propTypes["default"].string).isRequired,
  iconTooltip: _propTypes["default"].string,
  searchFieldHintText: _propTypes["default"].string,
  avatar: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool]),
  selectable: _propTypes["default"].bool,
  preSelected: _propTypes["default"].objectOf(_propTypes["default"].bool),
  useAsTable: _propTypes["default"].bool,
  showConnectionStatuses: _propTypes["default"].bool
};
var defaultProps = {
  data: {},
  // width: undefined,
  selectable: false,
  useAsTable: false,
  selectComponent: undefined,
  onSelected: function onSelected() {},
  searchFieldHintText: 'Search',
  iconTooltip: '',
  avatar: false,
  preSelected: undefined,
  showConnectionStatuses: false
};

var SearchableExpandableTableC =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SearchableExpandableTableC, _React$Component);

  function SearchableExpandableTableC(props) {
    var _this;

    _classCallCheck(this, SearchableExpandableTableC);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SearchableExpandableTableC).call(this, props));

    _this.getCheckboxComponent = function (obj) {
      var _this$props = _this.props,
          classes = _this$props.classes,
          avatar = _this$props.avatar,
          iconTooltip = _this$props.iconTooltip;
      var checked = _this.state.checked;
      var objRid = obj.rid;
      var objAvatar = obj.avatar || avatar;
      return avatar ? _react["default"].createElement(_FlippableAvatar.FlippableAvatar, {
        src: objAvatar,
        style: {
          padding: 0,
          paddingRight: 16
        },
        onChange: _this.handleChecked(objRid),
        tooltipText: iconTooltip
      }) : _react["default"].createElement(_Checkbox["default"], {
        className: classes.checkboxes,
        checked: checked[objRid] || false,
        onClick: function onClick(ev) {
          return ev.stopPropagation();
        },
        onChange: function onChange(ev, isChecked) {
          return _this.handleChecked(objRid)(isChecked);
        }
      });
    };

    _this.createConnectionIndicator = function (connectionStatus) {
      var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 20;
      var fillColor = {
        "true": 'lightgreen',
        "false": 'red',
        undefined: 'gray'
      }[connectionStatus]; // const fillColor = R.cond([
      //   [R.equals(true), R.always('lightgreen')],
      //   [R.equals(false), R.always('red')],
      //   [R.T, R.always('gray')],
      // ])(connectionStatus);

      return _react["default"].createElement("svg", {
        height: size,
        width: size
      }, _react["default"].createElement("circle", {
        cx: size / 2,
        cy: size / 2,
        r: "6",
        stroke: "black",
        strokeWidth: "0.5",
        fill: fillColor
      }));
    };

    _this.createAvatar = function (objAvatar) {
      var _this$props2 = _this.props,
          avatar = _this$props2.avatar,
          classes = _this$props2.classes,
          iconTooltip = _this$props2.iconTooltip;
      var src;
      var text;

      if (typeof avatar === 'boolean') {
        text = objAvatar.length < 3 ? objAvatar : undefined;
        src = objAvatar.length > 3 ? objAvatar : undefined;
      } else {
        text = avatar.length < 3 ? avatar : undefined;
        src = avatar.length > 3 ? avatar : undefined;
      }

      return _react["default"].createElement(_Tooltip["default"], {
        id: "tooltip".concat(objAvatar),
        title: iconTooltip,
        placement: "bottom-start"
      }, _react["default"].createElement("div", {
        className: classes.avatar
      }, _react["default"].createElement(_Avatar["default"], {
        src: src
      }, text)));
    };

    _this.handleSearchText = function (ev) {
      return _this.setState({
        searchText: ev.target.value
      });
    };

    _this.handlePanelChange = function (panel) {
      return function (event, expanded) {
        _this.setState({
          expanded: expanded ? panel : false
        });
      };
    };

    _this.handleChecked = function (rid) {
      return function (isChecked) {
        var checked = _this.state.checked;
        var onSelected = _this.props.onSelected; // console.log('handlechecked', checked, rid, isChecked);

        var newChecked = _objectSpread({}, checked, _defineProperty({}, rid, isChecked));

        _this.setState({
          checked: newChecked
        });

        onSelected(Object.keys(R.filter(function (v) {
          return v;
        }, newChecked)));
      };
    };

    _this.state = {
      searchText: '',
      checked: props.preSelected || {}
    };
    return _this;
  }

  _createClass(SearchableExpandableTableC, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          classes = _this$props3.classes,
          theme = _this$props3.theme,
          data = _this$props3.data,
          searchFieldHintText = _this$props3.searchFieldHintText,
          headings = _this$props3.headings,
          selectComponent = _this$props3.selectComponent,
          selectable = _this$props3.selectable,
          useAsTable = _this$props3.useAsTable,
          avatar = _this$props3.avatar,
          showConnectionStatuses = _this$props3.showConnectionStatuses;
      var _this$state = this.state,
          expanded = _this$state.expanded,
          checked = _this$state.checked,
          searchText = _this$state.searchText;
      var filteredObjects = R.filter(function (obj) {
        return filterHelper(obj.values, searchText);
      }, data); // TODO: no container anymore, make new API for small screen adaptation

      var smallScreen = theme.breakpoints.down('md'); // console.log('SearchableExpandableTable:', windowWidth, theme.breakpoints.values.md);

      var topLevelHeadings = smallScreen ? headings.slice(0, 2) : headings.slice(0, 4);
      var detailHeadings = smallScreen ? headings.slice(2, headings.length) : headings.slice(4, headings.length);
      var firstColumnPadding = theme.spacing(3);
      if (selectable) firstColumnPadding = theme.spacing(6) + iconSizeCompensation - 12;
      if (avatar) firstColumnPadding = theme.spacing(6) + iconSizeCompensation;
      return _react["default"].createElement("div", {
        className: classes.container
      }, _react["default"].createElement("div", {
        className: classes.flexContainer
      }, _react["default"].createElement("div", {
        className: classes.searchField
      }, _react["default"].createElement(_TextField["default"], {
        id: "search",
        label: searchFieldHintText,
        onChange: this.handleSearchText
      })), _react["default"].createElement("div", {
        className: classes.tools
      }, R.any(function (v) {
        return v;
      }, checked) && _react["default"].createElement("div", {
        className: classes.selectComponent
      }, selectComponent))), _react["default"].createElement("div", {
        className: classes.headings,
        style: {
          paddingLeft: firstColumnPadding
        }
      }, topLevelHeadings.map(function (title, i) {
        return _react["default"].createElement("div", {
          key: title || i,
          style: {
            flexBasis: "".concat(100 / topLevelHeadings.length, "%")
          }
        }, _react["default"].createElement(_Typography["default"], {
          className: classes.heading
        }, title));
      })), Object.values(filteredObjects).map(function (obj) {
        var objRid = obj.rid;
        var _obj$connectionStatus = obj.connectionStatus,
            connectionStatus = _obj$connectionStatus === void 0 ? undefined : _obj$connectionStatus;
        var isExpanded = expanded === objRid;
        var primaryAction = obj.actions && obj.actions[Object.keys(obj.actions)[0]] || selectable && {
          action: function action() {
            return _this2.handleChecked(objRid)(!checked.objRid || false);
          }
        };
        var topLevelValues = smallScreen ? R.slice(0, 2, obj.values) : R.slice(0, 4, obj.values);
        var detailValues = R.drop(smallScreen ? 2 : 4, obj.values);
        return _react["default"].createElement(_ExpansionPanel["default"], {
          key: objRid,
          expanded: isExpanded,
          onChange: useAsTable ? primaryAction && primaryAction.action : _this2.handlePanelChange(objRid)
        }, primaryAction && _react["default"].createElement("link", {
          className: classes.primaryAction,
          onClick: primaryAction.action
        }), primaryAction && primaryAction.tooltip && _react["default"].createElement(_Tooltip["default"], {
          id: "tooltip".concat(objRid),
          title: primaryAction.tooltip,
          placement: "right"
        }, _react["default"].createElement("link", {
          className: classes.primaryAction,
          onClick: primaryAction.action
        })), _react["default"].createElement(_ExpansionPanelSummary["default"], {
          className: (0, _classnames["default"])(useAsTable && classes.expandHeaderHover),
          classes: {
            expandIcon: primaryAction && primaryAction.icon && isExpanded && classes.expandIcon
          },
          expandIcon: !useAsTable && (primaryAction && primaryAction.icon && _react["default"].createElement(_Icon["default"], null, primaryAction.icon) || _react["default"].createElement(_Icon["default"], null, "expand_more"))
        }, showConnectionStatuses && _this2.createConnectionIndicator(connectionStatus), selectable && _this2.getCheckboxComponent(obj), !selectable && avatar && _this2.createAvatar(obj.avatar), topLevelValues.map(function (tlv, index) {
          return _react["default"].createElement("div", {
            // eslint-disable-next-line
            key: "".concat(index, "/").concat(tlv),
            style: {
              flexBasis: "".concat(100 / topLevelHeadings.length, "%")
            }
          }, _react["default"].createElement(_Typography["default"], {
            className: avatar ? classes.expandHeader : undefined
          }, tlv));
        })), detailValues.length > 0 && _react["default"].createElement(_ExpansionPanelDetails["default"], null, detailValues.map(function (dval, i) {
          return _react["default"].createElement("div", {
            key: dval,
            style: {
              flexBasis: '33.3%'
            }
          }, _react["default"].createElement(_Typography["default"], null, "".concat(detailHeadings[i], ": ").concat(dval)));
        })), obj.content && _react["default"].createElement(_ExpansionPanelDetails["default"], null, _react["default"].createElement("div", {
          className: classes.content
        }, obj.content(obj))), obj.actions && _react["default"].createElement(_Divider["default"], null), obj.actions && _react["default"].createElement(_ExpansionPanelActions["default"], {
          classes: {
            root: classes.actionsPanel
          }
        }, Object.values(obj.actions).map(function (action) {
          return _react["default"].createElement(_BottomNavigationAction["default"], {
            key: action.label,
            showLabel: true,
            onClick: action.action,
            label: action.label,
            icon: _react["default"].createElement(_Icon["default"], null, action.icon)
          });
        })));
      }));
    }
  }]);

  return SearchableExpandableTableC;
}(_react["default"].Component);

SearchableExpandableTableC.propTypes = propTypes;
SearchableExpandableTableC.defaultProps = defaultProps;
var SearchableExpandableTable = (0, _styles.withStyles)(styles, {
  withWidth: true,
  withTheme: true
})(SearchableExpandableTableC);
exports.SearchableExpandableTable = SearchableExpandableTable;