"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StaticChart = exports.pointsToChartData = exports.sliceData = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _chart = _interopRequireDefault(require("chart.js"));

var _styles = require("@material-ui/core/styles");

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _HorizontalTableCell = require("i4-js-commons/dist/ui/HorizontalTableCell");

var R = _interopRequireWildcard(require("ramda"));

var _Slider = _interopRequireDefault(require("@material-ui/core/Slider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var PositionSlider = (0, _styles.withStyles)(function (theme) {
  return {
    thumb: {
      '& .bar': {
        width: 2,
        height: 30,
        position: 'relative',
        top: -14,
        opacity: 0.38,
        backgroundColor: theme.palette.primary.main
      }
    }
  };
})(_Slider["default"]);

var PositionThumb = function PositionThumb(props) {
  return _react["default"].createElement("span", props, _react["default"].createElement("span", {
    className: "bar"
  }));
};

var sliceData = function sliceData() {
  var inData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var start = arguments.length > 1 ? arguments[1] : undefined;
  var end = arguments.length > 2 ? arguments[2] : undefined;
  var _inData$datasets = inData.datasets,
      datasets = _inData$datasets === void 0 ? [] : _inData$datasets,
      _inData$labels = inData.labels,
      labels = _inData$labels === void 0 ? [] : _inData$labels;

  var dataSlicer = function dataSlicer(data) {
    return data.slice(start, end);
  };

  var newDatasets = R.map(function (_ref) {
    var _ref$data = _ref.data,
        data = _ref$data === void 0 ? [] : _ref$data,
        dataset = _objectWithoutProperties(_ref, ["data"]);

    return _objectSpread({}, dataset, {
      data: dataSlicer(data)
    });
  })(datasets);
  return _objectSpread({}, inData, {
    datasets: newDatasets,
    labels: dataSlicer(labels)
  });
};

exports.sliceData = sliceData;

var pointsToChartData = function pointsToChartData(label) {
  var points = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  /* eslint-disable no-param-reassign */
  if (!points.length) points = [{
    ts: new Date(),
    pl: []
  }];
  /* eslint-enable no-param-reassign */

  var datasets = [];

  var _points = points,
      _points2 = _slicedToArray(_points, 1),
      pl = _points2[0].pl;

  pl.forEach(function (_, ix) {
    datasets.push({
      label: pl.length === 1 ? label : "".concat(label, "-").concat(ix),
      data: R.compose(R.pluck(ix), R.pluck('pl'))(points),
      lineTension: 0
    });
  });
  return {
    labels: R.pluck('ts')(points),
    datasets: datasets
  };
};

exports.pointsToChartData = pointsToChartData;
var propTypes = {
  points: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func]),
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  type: _propTypes["default"].string,
  title: _propTypes["default"].string,
  metrics: _propTypes["default"].arrayOf(_propTypes["default"].object),
  rangeSelector: _propTypes["default"]["boolean"],
  onRange: _propTypes["default"].func,
  options: _propTypes["default"].objectOf(_propTypes["default"].any),
  data: _propTypes["default"].objectOf(_propTypes["default"].any),
  range: _propTypes["default"].arrayOf(_propTypes["default"].number)
};
var defaultProps = {
  style: {},
  type: 'line',
  title: 'noname',
  options: {},
  metrics: undefined,
  data: undefined,
  points: undefined,
  onRange: undefined,
  range: undefined,
  rangeSelector: false
};
var pointRadius = 1.5;
var fill = false;
var borderWidth = 1;
var chartColors = ['rgb(50, 152, 235)', 'rgb(255, 159, 64)', 'rgb(75, 185, 92)', 'rgb(153, 102, 255)', 'rgb(255, 99, 99)', 'rgb(255, 205, 86)', 'rgb(190, 90, 60)', 'rgb(231, 80, 200)', 'rgb(60, 203, 180)', 'rgb(255, 20, 0)', 'rgb(201, 203, 207)'];
var defaultCanvasStyle = {
  width: 300,
  height: 640
};
var commonOptions = {
  animation: undefined,
  // { duration: 200 },
  legend: {
    labels: {
      boxWidth: 6
    }
  },
  maintainAspectRatio: false,
  responsive: true
};
var defaultOptions = {
  // bar: {
  //   ...commonOptions,
  // },
  line: _objectSpread({}, commonOptions, {
    // tooltips: { enabled: false },
    scales: {
      xAxes: [{
        type: 'time',
        time: {
          // parser: 'mm:ss',
          tooltipFormat: 'd MMM H:mm:ss.SSS',
          minUnit: 'second',
          displayFormats: {
            millisecond: 'H:mm:ss.SSS',
            second: 'H:mm:ss',
            minute: 'H:mm',
            hour: 'M-d H'
          }
        }
      }],
      yAxes: [// {
        //   scaleLabel: {
        //     // display: false,
        //     // labelString: 'value',
        //   },
        // },
      ]
    }
  })
};
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    metricCell: {
      marginRight: theme.spacing(3)
    },
    metricsSection: {
      display: 'flex',
      flexWrap: 'wrap'
    },
    serieMetricsBox: {
      marginRight: theme.spacing(4),
      marginBottom: theme.spacing(2)
    },
    container: {
      position: 'relative',
      margin: 'auto' // width: '100vw',

    }
  };
});

var StaticChartC = function StaticChartC(_ref2) {
  var style = _ref2.style,
      type = _ref2.type,
      title = _ref2.title,
      points = _ref2.points,
      options = _ref2.options,
      inData = _ref2.data,
      rangeSelector = _ref2.rangeSelector,
      onRange = _ref2.onRange,
      range = _ref2.range,
      metrics = _ref2.metrics,
      rest = _objectWithoutProperties(_ref2, ["style", "type", "title", "points", "options", "data", "rangeSelector", "onRange", "range", "metrics"]);

  var classes = useStyles();
  var canvasRef = (0, _react.useRef)(null);
  var chart = (0, _react.useRef)(null);
  var dataRef = (0, _react.useRef)(inData || {});

  var _useState = (0, _react.useState)([0, 100]),
      _useState2 = _slicedToArray(_useState, 2),
      contrRange = _useState2[0],
      setContrRange = _useState2[1];

  var _useState3 = (0, _react.useState)([0, 1]),
      _useState4 = _slicedToArray(_useState3, 2),
      sliderRange = _useState4[0],
      setSliderRange = _useState4[1];

  var rangeMean = R.mean(range || contrRange);
  (0, _react.useEffect)(function () {
    // console.log('Chart init:', type, JSON.stringify(points));
    dataRef.current = inData || pointsToChartData(title, points);
    /* eslint-disable no-param-reassign */

    (dataRef.current.datasets || []).forEach(function (ds, ix) {
      if (!ds.backgroundColor) ds.backgroundColor = chartColors[ix];
      if (!ds.borderColor) ds.borderColor = chartColors[ix];
      if (!ds.pointRadius) ds.pointRadius = pointRadius;
      if (!ds.fill) ds.fill = fill;
      if (!ds.borderWidth) ds.borderWidth = borderWidth;
    });
    /* eslint-enable no-param-reassign */

    chart.current = new _chart["default"](canvasRef.current, {
      type: type,
      data: dataRef.current,
      options: R.mergeDeepLeft(options, defaultOptions[type])
    });
    var fullRange = [0, dataRef.current.labels.length - 1];
    setSliderRange(fullRange);
    if (onRange) onRange(fullRange, chart.current.data);else if (!range) setContrRange(fullRange);
  }, [points, inData, options, title, type, onRange, range]);
  var onRangeChange = (0, _react.useCallback)(function (ev, val) {
    var _val = _slicedToArray(val, 2),
        left = _val[0],
        right = _val[1];

    chart.current.data = sliceData(dataRef.current, left, right);
    chart.current.update();
    if (onRange) onRange(val, chart.current.data);else if (!range) setContrRange(val);
  }, [range, onRange]);
  var onPositionChange = (0, _react.useCallback)(function (ev, pair) {
    var mean = R.mean(pair);
    var val = mean < rangeMean ? pair[0] : pair[1];

    var _ref3 = range || contrRange,
        _ref4 = _slicedToArray(_ref3, 2),
        left = _ref4[0],
        right = _ref4[1];

    var length = right - left;
    var newLeft = Math.max(0, val - length / 2);
    if (newLeft > sliderRange[1] - length) newLeft = sliderRange[1] - length;
    var newRight = newLeft + length;
    onRangeChange(ev, [newLeft, newRight]);
  }, [contrRange, onRangeChange, range, rangeMean, sliderRange]);

  var canvasStyle = _objectSpread({}, defaultCanvasStyle, {}, style);

  return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("div", {
    className: classes.container
  }, _react["default"].createElement("canvas", _extends({
    ref: canvasRef,
    width: canvasStyle.width,
    height: canvasStyle.height,
    style: canvasStyle
  }, rest))), !!rangeSelector && _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_Slider["default"], {
    value: range || contrRange,
    onChange: onRangeChange,
    valueLabelDisplay: "off",
    "aria-labelledby": "range-slider",
    min: sliderRange[0],
    max: sliderRange[1]
  }), _react["default"].createElement(PositionSlider, {
    ThumbComponent: PositionThumb,
    value: [rangeMean, rangeMean],
    onChange: onPositionChange,
    valueLabelDisplay: "off",
    "aria-labelledby": "position-slider",
    min: sliderRange[0],
    max: sliderRange[1]
  })), !!chart.current && !!metrics && _react["default"].createElement("section", {
    className: classes.metricsSection
  }, R.map(function (_ref5) {
    var data = _ref5.data,
        dsLabel = _ref5.label;
    return _react["default"].createElement("div", {
      key: "".concat(title, "-").concat(dsLabel),
      className: classes.serieMetricsBox
    }, _react["default"].createElement(_Typography["default"], {
      variant: "subtitle1",
      gutterBottom: true
    }, dsLabel), _react["default"].createElement("div", null, R.map(function (_ref6) {
      var id = _ref6.id,
          label = _ref6.label,
          f = _ref6.f;
      var result = f(data); // console.log('Metric:', result);

      return _react["default"].createElement(_HorizontalTableCell.HorizontalTableCell, {
        className: classes.metricCell,
        key: "".concat(title, "-").concat(id),
        label: label || id,
        content: result
      });
    })(metrics)));
  })(chart.current.data.datasets || [])));
};

StaticChartC.propTypes = propTypes;
StaticChartC.defaultProps = defaultProps;
var StaticChart = StaticChartC;
exports.StaticChart = StaticChart;