"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ThresholdGauge = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/styles");

var _gaugeface = require("gauge-animated/lib/gaugeface");

var _lib = require("gauge-animated/lib");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function hexToRgbArray(hexStr) {
  // console.log('hexToRgbArray:', hexStr);
  return [0, 0, 0].map(function (v, i) {
    return parseInt((hexStr.startsWith('#') ? hexStr.slice(1) : hexStr).slice(i * 2, 2 * (i + 1)), 16);
  });
}

var rgbArrayToStr = function rgbArrayToStr(rgb) {
  return "rgb(".concat(rgb.join(','), ")");
};

var hexToRgbStr = function hexToRgbStr(x) {
  return rgbArrayToStr(hexToRgbArray(x));
};

var isEven = function isEven(n) {
  return Math.abs(n % 2) === 0;
};

var limitMapper = function limitMapper(min, max, thresholds) {
  return function (step) {
    return thresholds[thresholds.reduce(function (res, limit, ix) {
      // console.log('thresholds.reduce:', step, limit, ix, res);
      if (ix + 1 === thresholds.length && res === -1) return ix;
      var notALimit = isEven(ix);
      var valueFound = res > -1;
      var value = min + step * (max - min) / 100;
      var doContinue = value > limit;

      if (notALimit || valueFound || doContinue) {
        return res;
      }

      return ix - 1;
    }, -1)];
  };
};

var limitMapperToRgbStr = function limitMapperToRgbStr(min, max, thresholds) {
  var mapper = limitMapper(min, max, thresholds);
  return function (step) {
    return hexToRgbStr(mapper(step));
  };
};

var svgNeedle = function svgNeedle(size) {
  var c = 250;
  var scale = size / 500;
  return (0, _gaugeface.stringToElement)("<svg viewBox=\"0 0 ".concat(size, " ").concat(size, "\" xmlns=\"http://www.w3.org/2000/svg\" style=\"width:").concat(size, "px; height:").concat(size, "px;\">\n\n    <g>\n\n      <g transform=\"scale(").concat(scale, ")\">\n\n        <circle cx=\"").concat(c, "\" cy=\"").concat(c, "\" r=\"18\" style=\"fill:#000\"/>\n\n        <path d=\"M ").concat(c, " ").concat(c + 3.5, " L ").concat(c * 1.66, " ").concat(c + 2, " L ").concat(c * 1.6, " ").concat(c + 15, " L ").concat(c * 1.9, " ").concat(c, " L ").concat(c * 1.6, " ").concat(c - 15, " L ").concat(c * 1.66, " ").concat(c - 2, " L ").concat(c, " ").concat(c - 3.5, " z\" fill=\"#000\" stroke=\"#111\"/>\n\n        <path d=\"M ").concat(c, " ").concat(c + 4, " L ").concat(c - 75, " ").concat(c + 4, " L ").concat(c - 75, " ").concat(c - 4, " L ").concat(c, " ").concat(c - 4, " z\" fill=\"#000\" stroke=\"#111\"/>\n\n        <circle cx=\"").concat(c - 80, "\" cy=\"").concat(c, "\" r=\"17\" style=\"fill:#000\"/>\n\n        <circle cx=\"").concat(c - 80, "\" cy=\"").concat(c, "\" r=\"6.5\" style=\"fill:#fff\"/>\n\n        <circle cx=\"").concat(c, "\" cy=\"").concat(c, "\" r=\"4\" style=\"stroke:#999;fill:#ccc\"/>\n\n      </g>\n\n    </g>\n\n    </svg>"));
};

var hoc = _styles.withTheme;
var propTypes = {
  theme: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  thresholds: _propTypes["default"].arrayOf(_propTypes["default"].any),
  // startColor: PropTypes.string,
  // endColor: PropTypes.string,
  size: _propTypes["default"].number,
  min: _propTypes["default"].number,
  max: _propTypes["default"].number,
  value: _propTypes["default"].number,
  markerColors: _propTypes["default"].func,
  valueDisplayPostfix: _propTypes["default"].string
};
var defaultProps = {
  // startColor: 'ff0000',
  // endColor: '00ff00',
  size: 250,
  min: 0,
  max: 100,
  value: undefined,
  markerColors: undefined,
  valueDisplayPostfix: '',
  style: {},
  thresholds: ['#00dd80', 60, '#F7D802', 80, '#ff5630']
};

var ThresholdGaugeC = function ThresholdGaugeC(_ref) {
  var min = _ref.min,
      max = _ref.max,
      thresholds = _ref.thresholds,
      markerColors = _ref.markerColors,
      theme = _ref.theme,
      value = _ref.value,
      size = _ref.size,
      style = _ref.style,
      rest = _objectWithoutProperties(_ref, ["min", "max", "thresholds", "markerColors", "theme", "value", "size", "style"]);

  var gauge = (0, _react.useRef)();
  var div = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    var fontFamily = ' ';

    var options = _objectSpread({
      size: size,
      // fontFamily,
      // scaleLabelFontFamily: fontFamily,
      // faceTextFontFamily: fontFamily,
      valueDisplayFontFamily: fontFamily,
      startAngle: Math.PI * 0.6,
      stopAngle: Math.PI * 2.4,
      needleAngleMin: Math.PI * 0.5,
      needleAngleMax: Math.PI * 2.5,
      labelSteps: 0,
      stopPinColor: 0,
      markerWidth: size / 29,
      markerLength: size * 0.16,
      markerColors: markerColors || limitMapperToRgbStr(min, max, thresholds),
      valueDisplay: true,
      // valueDisplayRadius: 0,
      valueDisplayFontSize: size / 10,
      min: min,
      max: max,
      stepValue: (max - min) / 100,
      mediumSteps: 0,
      largeSteps: 0,
      needleSvg: svgNeedle
    }, rest);

    div.current.innerHTML = '';
    gauge.current = (0, _lib.createGauge)(div.current, options); // gauge.current.setTarget(value);
  }, [markerColors, size, min, max, thresholds, rest]);
  (0, _react.useEffect)(function () {
    if (!gauge.current) return;
    gauge.current.setTarget(value);
  }, [value, gauge.current]);
  return _react["default"].createElement("div", {
    style: _objectSpread({
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      overflow: 'hidden'
    }, style)
  }, _react["default"].createElement("style", null, ".gauge-value-display { font-size: ".concat(size / 8, "px }")), _react["default"].createElement("div", {
    ref: div
  }));
};

ThresholdGaugeC.propTypes = propTypes;
ThresholdGaugeC.defaultProps = defaultProps;
var ThresholdGauge = hoc(ThresholdGaugeC);
exports.ThresholdGauge = ThresholdGauge;