"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Widget = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _Card = _interopRequireDefault(require("@material-ui/core/Card"));

var _CardHeader = _interopRequireDefault(require("@material-ui/core/CardHeader"));

var _CardContent = _interopRequireDefault(require("@material-ui/core/CardContent"));

var _ListItemIcon = _interopRequireDefault(require("@material-ui/core/ListItemIcon"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _Menu = _interopRequireDefault(require("@material-ui/core/Menu"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Icon = _interopRequireDefault(require("@material-ui/core/Icon"));

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _FlexIcon = require("./FlexIcon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var contentHeight = 332;
var titlePadding = 16;
var titleHeight = 64;
var settingsIconSize = 48;
var tooltipIconSize = 30;

var styles = function styles() {
  return {
    card: {
      position: 'relative',
      display: 'inline-grid',
      // '&:last-child': { marginBottom: theme.spacing(1) },
      gridTemplateRows: "".concat(titleHeight, "px auto") // enforce title height

    },
    tooltipContainer: {
      position: 'absolute',
      // right: 48,
      top: 8
    },
    tooltipBody: {
      maxWidth: 180
    },
    cardContentRoot: {
      '&:last-child': {
        paddingBottom: 0
      }
    },
    cardContent: {
      width: '100%',
      padding: 0,
      display: 'flex',
      justifyContent: 'center'
    },
    title: {
      overflow: 'hidden',
      textOverflow: 'ellipsis',
      whiteSpace: 'nowrap'
    },
    settingsMenu: {
      position: 'absolute',
      top: titleHeight / 2 - settingsIconSize / 2
    },
    tooltip: {
      position: 'absolute',
      top: titleHeight / 2 - tooltipIconSize / 2
    }
  };
};

var propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  contentStyle: _propTypes["default"].objectOf(_propTypes["default"].any),
  width: _propTypes["default"].number.isRequired,
  height: _propTypes["default"].number,
  title: _propTypes["default"].string,
  tooltip: _propTypes["default"].string,
  children: _propTypes["default"].node.isRequired,
  // settingsCallback: PropTypes.func,
  menuItems: _propTypes["default"].arrayOf(_propTypes["default"].object),
  style: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var defaultProps = {
  style: {},
  contentStyle: {},
  title: 'Untitled',
  height: contentHeight,
  // settingsCallback: () => {},
  menuItems: undefined,
  tooltip: undefined
};

var WidgetC =
/*#__PURE__*/
function (_React$Component) {
  _inherits(WidgetC, _React$Component);

  function WidgetC() {
    var _getPrototypeOf2;

    var _temp, _this;

    _classCallCheck(this, WidgetC);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _possibleConstructorReturn(_this, (_temp = _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(WidgetC)).call.apply(_getPrototypeOf2, [this].concat(args))), _this.state = {
      anchorEl: undefined,
      hasError: false
    }, _this.handleMenuItem = function (method) {
      return function () {
        method();

        _this.handleMenuClose();
      };
    }, _this.handleMenuClick = function (e) {
      e.stopPropagation();

      _this.setState({
        anchorEl: e.currentTarget
      });
    }, _this.handleMenuClose = function () {
      _this.setState({
        anchorEl: undefined
      });
    }, _temp));
  }

  _createClass(WidgetC, [{
    key: "componentDidCatch",
    value: function componentDidCatch(error, info) {
      // You can also log the error to an error reporting service
      console.warn(error, info);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          title = _this$props.title,
          tooltip = _this$props.tooltip,
          width = _this$props.width,
          height = _this$props.height,
          children = _this$props.children,
          menuItems = _this$props.menuItems,
          style = _this$props.style,
          contentStyle = _this$props.contentStyle;
      var _this$state = this.state,
          anchorEl = _this$state.anchorEl,
          hasError = _this$state.hasError;
      var titleWidth = width - titlePadding - (tooltip ? settingsIconSize + tooltipIconSize : settingsIconSize);
      var titleFontSize = "".concat(title.length >= 20 && width < 400 ? 1.5 - (title.length - 20) / 30 : 1.5, "rem");
      return _react["default"].createElement(_Card["default"], {
        className: classes.card,
        style: _objectSpread({
          height: (height || contentHeight) + titleHeight,
          width: width
        }, style)
      }, _react["default"].createElement(_CardHeader["default"], {
        classes: {
          title: classes.title
        },
        style: {
          maxWidth: titleWidth
        },
        title: _react["default"].createElement(_Typography["default"], {
          variant: "h5",
          noWrap: true,
          style: {
            maxWidth: titleWidth,
            fontSize: titleFontSize
          }
        }, title),
        action: menuItems && _react["default"].createElement("div", null, _react["default"].createElement(_IconButton["default"], {
          "aria-label": "widget-button",
          "aria-owns": anchorEl ? 'widget-menu' : null,
          "aria-haspopup": "true",
          disabled: hasError,
          onClick: this.handleMenuClick,
          className: classes.settingsMenu,
          style: {
            left: width - settingsIconSize
          }
        }, _react["default"].createElement(_FlexIcon.FlexIcon, {
          icon: "more_vert"
        })), _react["default"].createElement(_Menu["default"], {
          id: "widget-menu",
          anchorEl: anchorEl,
          open: !!anchorEl,
          onClose: this.handleMenuClose,
          transitionDuration: 100
        }, menuItems.map(function (conf) {
          return _react["default"].createElement(_MenuItem["default"], {
            key: conf.label,
            onClick: _this2.handleMenuItem(conf.method)
          }, _react["default"].createElement(_ListItemIcon["default"], null, _react["default"].createElement(_FlexIcon.FlexIcon, {
            icon: conf.icon,
            color: "action"
          })), _react["default"].createElement(_ListItemText["default"], {
            primary: conf.label
          }));
        })))
      }), tooltip && _react["default"].createElement(_Tooltip["default"], {
        id: "".concat(title, "WidgetTooltip"),
        title: _react["default"].createElement("div", {
          className: classes.tooltipBody
        }, tooltip),
        placement: "bottom-end"
      }, _react["default"].createElement(_IconButton["default"], {
        className: classes.tooltipContainer,
        style: {
          right: menuItems ? 48 : 8
        }
      }, _react["default"].createElement(_Icon["default"], null, "help_outline"))), _react["default"].createElement(_CardContent["default"], {
        className: classes.cardContent,
        classes: {
          root: classes.cardContentRoot
        },
        style: _objectSpread({
          width: width
        }, contentStyle)
      }, hasError ? _react["default"].createElement("h4", null, "Something went wrong.") : children));
    }
  }], [{
    key: "getDerivedStateFromError",
    value: function getDerivedStateFromError() {
      // Update state so the next render will show the fallback UI.
      return {
        hasError: true
      };
    }
  }]);

  return WidgetC;
}(_react["default"].Component);

WidgetC.propTypes = propTypes;
WidgetC.defaultProps = defaultProps;
var Widget = (0, _styles.withStyles)(styles)(WidgetC); // , { withTheme: true }

exports.Widget = Widget;