"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withAsync = void 0;

var _react = _interopRequireWildcard(require("react"));

var _get = _interopRequireDefault(require("lodash/fp/get"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useAsync = function useAsync(func) {
  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var path = arguments.length > 2 ? arguments[2] : undefined;

  var _useState = (0, _react.useState)({
    result: undefined,
    error: undefined,
    loading: true
  }),
      _useState2 = _slicedToArray(_useState, 2),
      result = _useState2[0],
      setResult = _useState2[1];

  (0, _react.useEffect)(function () {
    if (func) func.apply(void 0, _toConsumableArray(args)).then(function (res) {
      setResult(function (prev) {
        return _objectSpread({}, prev, {
          result: path ? (0, _get["default"])(path, res) : res,
          loading: false
        });
      });
    })["catch"](function (err) {
      console.error(err);
      setResult(function (prev) {
        return _objectSpread({}, prev, {
          error: err.message,
          loading: false
        });
      });
    });
  }, []);
  return result;
};
/**
 * Higher Order Function for having a prop getting its value from an async call
 * @func
 * @static
 * @param {function} fetcher The function that returns a Promise
 * @returns {Component} A new component
 */


var withAsync = function withAsync(fetcher) {
  return function () {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$resultKey = _ref.resultKey,
        resultKey = _ref$resultKey === void 0 ? 'data' : _ref$resultKey,
        _ref$loadingKey = _ref.loadingKey,
        loadingKey = _ref$loadingKey === void 0 ? 'loading' : _ref$loadingKey,
        _ref$errorKey = _ref.errorKey,
        errorKey = _ref$errorKey === void 0 ? 'error' : _ref$errorKey,
        _ref$args = _ref.args,
        args = _ref$args === void 0 ? [] : _ref$args,
        path = _ref.path;

    var fetchFunc =
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", fetcher ? fetcher.apply(void 0, _toConsumableArray(args)) : undefined);

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function fetchFunc() {
        return _ref2.apply(this, arguments);
      };
    }();

    return function (Component) {
      var WithAsync = function WithAsync(props) {
        var _ref3;

        var _useAsync = useAsync(fetchFunc, args, path),
            result = _useAsync.result,
            loading = _useAsync.loading,
            error = _useAsync.error; // const { value, execute, loading, error } = useAsync(fetchFunc, args);


        return _react["default"].createElement(Component, _extends({}, props, (_ref3 = {}, _defineProperty(_ref3, resultKey, result), _defineProperty(_ref3, loadingKey, loading), _defineProperty(_ref3, errorKey, error), _ref3)));
      };

      return WithAsync;
    };
  };
};

exports.withAsync = withAsync;