"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withAsync = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactAsyncHook = require("react-async-hook");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var withAsync = function withAsync(fetcher) {
  return function () {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$resultKey = _ref.resultKey,
        resultKey = _ref$resultKey === void 0 ? 'data' : _ref$resultKey,
        _ref$loadingKey = _ref.loadingKey,
        loadingKey = _ref$loadingKey === void 0 ? 'loading' : _ref$loadingKey,
        _ref$errorKey = _ref.errorKey,
        errorKey = _ref$errorKey === void 0 ? 'error' : _ref$errorKey,
        _ref$args = _ref.args,
        args = _ref$args === void 0 ? [] : _ref$args;

    var fetchFunc =
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", fetcher ? fetcher.apply(void 0, _toConsumableArray(args)) : undefined);

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function fetchFunc() {
        return _ref2.apply(this, arguments);
      };
    }();

    console.log('withAsync fetcher & settings:', fetcher, resultKey, args);
    return function (Component) {
      console.log('withAsync hoc used on:', Component);

      var WithAsync = function WithAsync(props) {
        var _ref3;

        var asyncObj = (0, _reactAsyncHook.useAsync)(fetchFunc, args); // const { value, execute, loading, error } = useAsync(fetchFunc, args);

        console.log('WithAsync value, loading, error:', asyncObj, JSON.stringify(asyncObj));
        (0, _react.useEffect)(function () {
          asyncObj.execute();
        }, []);
        return _react["default"].createElement(Component, _extends({}, props, (_ref3 = {}, _defineProperty(_ref3, resultKey, asyncObj.value), _defineProperty(_ref3, loadingKey, asyncObj.loading), _defineProperty(_ref3, errorKey, asyncObj.error), _ref3)));
      };

      return WithAsync;
    };
  };
};

exports.withAsync = withAsync;