"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withChannelData = void 0;

var _react = _interopRequireDefault(require("react"));

var R = _interopRequireWildcard(require("ramda"));

var _lodash = _interopRequireDefault(require("lodash.get"));

var _beClient = require("./be-client");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// import { evolveTsToDate, ensureTsV3 } from './dm-utils';
// const get = require('lodash.get');
var act = function act(conf) {
  return function (pl) {
    return conf.forEach(function (ch) {
      return (0, _beClient.pub)(ch, pl);
    });
  };
};

function confToChannelNames(conf) {
  if (conf.channel && conf.channel.id) return [conf.channel.id];

  if (conf.channels) {
    return conf.channels.reduce(function (r, cc) {
      if (cc.id) r.push(cc.id);
      return r;
    }, []);
  }

  return [];
}
/**
 * DEPRECATED Higher Order Function for data subscriptions into props. Use withSub instead.
 * (Still needed if subscription needs to be combined with withUnits & withUnitsTransform ??)
 * @func
 * @static
 * @param {type} keyChannelMap A configuration of subscriptions in this form:
 * {
 *   <prop-name>: { init, actuator, subs: [{ rid, last, tail, ttl, path, transform }] }
 * }
 * where last is a bool, tail is a number and ttl is a number of seconds.
 * @returns {type} Description
 */


var withChannelData = function withChannelData(keyChannelMap) {
  return function (Component) {
    var WithChannelData__ =
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(WithChannelData__, _React$Component);

      function WithChannelData__(props) {
        var _this;

        _classCallCheck(this, WithChannelData__);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(WithChannelData__).call(this, props));
        _this.actuators = {};
        _this.subscriptions = [];

        if (!keyChannelMap || _typeof(keyChannelMap) !== 'object') {
          console.warn('WithChannelData keyChannelMap:', keyChannelMap);
          return _possibleConstructorReturn(_this);
        }

        _this.state = Object.entries(keyChannelMap).reduce(function (r, _ref) {
          var _ref2 = _slicedToArray(_ref, 2),
              key = _ref2[0],
              conf = _ref2[1];

          return conf.init !== undefined ? _objectSpread({}, r, _defineProperty({}, key, conf.init)) : r;
        }, {}); // console.log('withChannelData state init:', this.state);

        return _this;
      }

      _createClass(WithChannelData__, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var _this2 = this;

          if (!keyChannelMap || _typeof(keyChannelMap) !== 'object') return;
          Object.entries(keyChannelMap).forEach(function (_ref3) {
            var _ref4 = _slicedToArray(_ref3, 2),
                key = _ref4[0],
                conf = _ref4[1];

            // console.log('keyChannelMap key conf:', key, conf);
            if (conf.actuator) {
              _this2.actuators[key] = act(confToChannelNames(conf));
            }

            if (conf.subs) {
              conf.subs.forEach(function (channel) {
                if (!channel || channel.rid === undefined) return;
                var transform = channel.transform;
                var unsub = (0, _beClient.fromChannel)(_objectSpread({}, channel, {
                  // rid, last, tail, ttl, path
                  cb: _this2.onMsg({
                    key: key,
                    // path,
                    transform: transform || conf.transform
                  })
                }));
                if (unsub) _this2.subscriptions = R.append(unsub)(_this2.subscriptions);
              });
            }
          });
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.subscriptions.forEach(function (unsub) {
            return unsub();
          });
        }
      }, {
        key: "onMsg",
        value: function onMsg(_ref5) {
          var _this3 = this;

          var transform = _ref5.transform,
              key = _ref5.key,
              path = _ref5.path;
          return function (msg) {
            // console.log('onMsg', path, typeof transform, transform, key);
            var data = path ? (0, _lodash["default"])(msg, path) : msg; // if (transform && msg) {
            //   console.log('onMsg:', typeof transform, transform, key);
            // }

            _this3.setState(function (state) {
              var prevProp = state[key];
              if (data === undefined) return undefined;
              var value = transform ? transform(data, prevProp) : data; // if (transform && msg) {
              //   console.log('onMsg tr:', value);
              // }

              if (value === undefined) return undefined;
              return _defineProperty({}, key, value);
            });
          };
        }
      }, {
        key: "render",
        value: function render() {
          // console.log('withChannelData render:', this.props, this.state);
          return _react["default"].createElement(Component, _extends({}, this.props, this.state, this.actuators));
        }
      }]);

      return WithChannelData__;
    }(_react["default"].Component);

    return WithChannelData__;
  };
};

exports.withChannelData = withChannelData;