"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withSub = void 0;

var _react = _interopRequireWildcard(require("react"));

var R = _interopRequireWildcard(require("ramda"));

var _beClient = require("./be-client");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * Higher Order Component to add a subscription to a component
 * @func
 * @static
 * @param {object} settings Settings as { <prop-name>: { rid, init, last, tail, ttl, path } }
 * @returns {Component} A new component
 */
var withSub = function withSub(settings) {
  // settings: { myKey: { init: x, rid:'<aRid>'} }
  var msgKey = R.o(R.head, R.keys)(settings);
  var channel = settings[msgKey];
  return function (Component) {
    var WithSub = function WithSub(props) {
      var subscriptions = (0, _react.useRef)([]);

      var _useState = (0, _react.useState)(channel.init),
          _useState2 = _slicedToArray(_useState, 2),
          msg = _useState2[0],
          setMsg = _useState2[1];

      (0, _react.useEffect)(function () {
        if (!channel || channel.rid === undefined) return undefined;
        var unsub = (0, _beClient.fromChannel)(_objectSpread({}, channel, {
          // rid, last, tail, ttl, path
          cb: setMsg
        }));
        if (unsub) subscriptions.current = R.append(unsub)(subscriptions.current);
        return function () {
          return subscriptions.current.forEach(function (f) {
            return f();
          });
        };
      }, []);
      return _react["default"].createElement(Component, _extends({}, props, _defineProperty({}, msgKey, msg)));
    };

    return WithSub;
  };
};

exports.withSub = withSub;